/*
 * maptrick.c by eagan rackley. Greets to Debvgger for his fmp tilemap tutorial:), without which I would have been too lazy to do a map demo:)
 */
    
#include "huc.h" 
#include "global.c"


mainInit()
{
    set_screen_size(SCR_SIZE_64x64) ;
    set_map_data(map, MAP_XTILES, MAP_YTILES) ;
    set_tile_data(tiles, 20, paletteReference);
    load_tile(0x1000);
    set_bgpal(0, palette);
    
    load_map(0, 0, 0, 0, 32, 32);
}

/*
 * waveDisplace(waveArray, waveCount)
 * every 2 elements of waveArray = 1 waveCount
 * element 1 = Y location, element 2 = pass direction (copy from above, or below?)
 * if our screen is 64 in length, and with only 12 displaying, I think we should always begin the
 * wave at screen_H / 2, so in this case we'll use 32 as a starting point. Then, we will cancel, at
 * location 1, having scrolled up to this number, we will then need to re-set at 32.
 * 1st attempt, let's have 1 copying down, and one copying back up:)
 */
 waveDisplace(waveArray, waveCount) int * waveArray, waveCount;
 {
  int offsetSource, offsetDest, idx, *indexReg, *dataReg;
  indexReg = 0x0000;
  dataReg =  0x0002;
  for(idx = 0; idx < waveCount; idx++)
  {
    /*each row = 0x40, so each y location = 0x40 * y*/
    offsetDest   = waveArray[Y_VALUE+idx] * 0x40;
    offsetSource = offsetDest + (waveArray[Y_PASS+idx] * 0x40);

     *indexReg = 0xF;
     *dataReg  = 0x00;
     *indexReg = 0x10;
     *dataReg  = offsetSource;
     *indexReg = 0x11;
     *dataReg  = offsetDest;
     *indexReg = 0x12;
     *dataReg  = 0x3F;

    /*move our wave displace up a block this time :)*/
    waveArray[Y_VALUE+idx]+= waveArray[Y_PASS];
    if(waveArray[Y_VALUE+idx] <= 1 || waveArray[Y_VALUE+idx] >= 63 )
    {

    waveArray[Y_PASS] = -waveArray[Y_PASS];
    }
  }
 }
/*
 * some notes:
 * ok, we have a screen pattern at the begining of VRAM starting at address 00h
 * depending on what you've got setup for screen size (i'm using 64x32), you can
 * access this information:). the information is stored in 16bits PPPP AAAA AAAA AAAA
 * where PPPP is a 4 bit entry desribing 0-F for our palette, and then AAAA AAAA AAAA
 * points to an address in VRAM that holds the tile we wish to access:)
 * SO, in order to implement a fake water approach, all we need to do is copy that data
 * row by row. So, for the 2nd row of pixels onto the 1st (32*2bytes each) we would copy
 * bytes 65-128 to bytes 1-64 ;) etc.
 */
mainLoop()
{
  int scrollY, scrollX, velY, velX, cntr;
  int Displace[2], Displace2[2], Displace3[2], Displace4[2],Displace5[2],Displace6[2],Displace7[2],
  Displace8[2], Displace9[2],Displace10[2], Displace11[2];
  Displace[Y_VALUE] = 1;
  Displace[Y_PASS ] = -1;
  Displace2[Y_VALUE] = 4;
  Displace2[Y_PASS ] = -1;
  Displace3[Y_VALUE] = 7;
  Displace3[Y_PASS ] = -1;
  Displace4[Y_VALUE] = 11;
  Displace4[Y_PASS ] = -1;
  Displace5[Y_VALUE] = 14;
  Displace5[Y_PASS ] = -1;
  Displace6[Y_VALUE] = 17;
  Displace6[Y_PASS ] = -1;
  Displace7[Y_VALUE] = 20;
  Displace7[Y_PASS ] = -1;
/*  Displace8[Y_VALUE] = 64;
  Displace8[Y_PASS ] = -1;*/
/*  Displace9[Y_VALUE] = 39;
  Displace9[Y_PASS ] = -1;
  Displace10[Y_VALUE] = 49;
  Displace10[Y_PASS ] = -1;*/
  /*Displace11[Y_VALUE] = 61;
  Displace11[Y_PASS ] = -1; */



  scrollX = 4;
  scrollY = 4;
  velX = 1;
  velY = 1;
  cntr = 0;

  for(;;)
  {
   cntr++;
   if(cntr > 2)
   {
   scrollX+=velX;
   if(scrollX >= 256  || scrollX <= 1) velX =- velX;
   scrollY+=velY;
   if(scrollY >= 200 || scrollY < 4) velY =- velY;
   scroll(0, scrollX, scrollY, 0, 224, 0xC0) ; /*move down 8, so that we never see any messy tiles loaded off to the sides*/
   cntr = 0;
   waveDisplace(Displace, 1);
    waveDisplace(Displace2, 1);
   waveDisplace(Displace3, 1);
   waveDisplace(Displace4, 1);
   waveDisplace(Displace5, 1);
   waveDisplace(Displace6, 1);
   waveDisplace(Displace7, 1);
   }

  /*waveDisplace(Displace8, 1);
   waveDisplace(Displace9, 1);
  waveDisplace(Displace10, 1);  */
  /*waveDisplace(Displace11, 1);*/

   vsync();
  }
}



main()
{
    mainInit();
    mainLoop() ;
}


